﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Reflection;
using System.Text.RegularExpressions;

namespace XAMLTools
{
    internal class XamlHelper
    {
        internal static bool hasCollections(DependencyObject obj)
        {
            PropertyInfo[] props = obj.GetType().GetProperties();
            foreach (var prop in props)
                if (prop.Name != "Parent" && (prop.PropertyType.BaseType.Name == "Collection`1" || prop.PropertyType.Name == "Transform"))
                    return true;
            return false;
        }
        internal static bool hasDeepCollections(DependencyObject obj, PropertyInfo prop)
        {
            if (obj == null || prop.PropertyType.IsArray)
                return false;
            return ((prop.GetValue(obj, null) ?? new object()).ToString().StartsWith("System."));
        }
        internal static string getSilverlightCompatibleXaml(string xaml)
        {
            Regex reg = new Regex(@"(\<(/)?\w+\.Children\>)", RegexOptions.Compiled);
            return reg.Replace(xaml, "").Replace("xName", "x:Name");
        }
    }
}
